/**
 * Created by zhaofs on 2017/5/23.
 * ajax请求进一步封装
 */
export default {
    /**
     * ajax请求
     * @param args
     * {url:/demo/mybatisuser/pages-(必选),type:post-(默认)},可接受jquery.ajax的所有属性参数。
     */
    ajax: function (args) {
        if (args && args.url) {
            let ajaxOptions = $.extend({
                type: "post",
                cache: false,
                dataType: "json",
                data: {}
            }, args);

            //add lhw 20180530 增加urlSuffix处理，包括单个urlSuffix时修改url，和多个urlSuffix时异步同时发送多个ajax start
            if( ajaxOptions.urlSuffix ){
                if( typeof(ajaxOptions.urlSuffix)=='string' ){
                    ajaxOptions.url = ajaxOptions.url + ajaxOptions.urlSuffix;
                }else if( ajaxOptions.urlSuffix instanceof Array ) {
                    if( ajaxOptions.urlSuffix.length == 0 ){
                        //do nothing
                    }else if( ajaxOptions.urlSuffix.length == 1 ){
                        ajaxOptions.url = ajaxOptions.url + ajaxOptions.urlSuffix[0];
                    }else {
                        var promiseArray = new Array();
                        for (var i = 0; i < ajaxOptions.urlSuffix.length; i++) {
                            var aOption = {};
                            $.extend(true, aOption, ajaxOptions);
                            aOption.url = aOption.url + ajaxOptions.urlSuffix[i];
                            var aPromise = new Promise(function (resolve, reject) {
                                $.ajax(aOption).then((data) => {
                                    if (data.code === '0') {
                                        resolve(data || {});
                                        //兼容老系统
                                    } else if (data.success) {
                                        resolve(data.content || {});
                                    } else {
                                        reject(data);
                                    }
                                });
                            });
                            promiseArray.push(aPromise);
                        }
                        return Promise.all(promiseArray);
                    }
                }
            }
            //add end

            return new Promise((resolve, reject) => {
                $.ajax(ajaxOptions).then((data) => {
                    if (data.code === '0') {
                        resolve(data|| {});

                        //兼容老系统
                    } else if (data.success) {
                        resolve(data.content || {});
                    } else {
                        reject(data);
                    }
                });
            });
        } else {
            throw new Error("参数无效，请传递如{url:/demo/mybatisuser/pages-(必选),type:post-(默认)}的JS对象");
        }
    }
};
