/**
 * Created by zhaofs on 2018/5/19.
 * --------------------
 * - Handle切面调用实现 -
 * --------------------
 * 实现对Handler方法切面编程
 */
import aspectManager from "./AspectManager";

export default {


    /**
     * 对路由前进行调用
     * @param fn({href,path,method,args}) 回调方法
     */
    routeBefore: function (fn) {
        aspectManager.get("doRouteBefore").push(fn);
    },

    /**
     * 对路由前进行调用
     * @param fn({href,path,method,args}) 回调方法
     */
    routeAfter: function (fn) {
        aspectManager.get("doRouteAfter").push(fn);
    },

    /**
     * Handler方法调用前拦截处理
     * @param href Handler全路径
     * @param fn 回调方法
     */
    invokeBefore: function (href, fn) {
        aspectManager.get("invokeBefore").set(href,fn);
    },

    /**
     * Handler方法调用前拦截处理
     * @param href Handler全路径
     * @param fn 回调方法
     */
    invokeAfter: function (href, fn) {
        aspectManager.get("invokeAfter").set(href,fn);
    },

};