/**
 * Created by zhaofs on 2017/12/21.
 * --------------------
 * - 模块管理 -
 * --------------------
 * 实现对模块统一管理
 */
let modules = new Map();

export default {

    /**
     * 添加模块
     * @param nodule
     */
    add:function (module) {
        if(!modules.has(module.name)){
            modules.set(module.name,module);
        }else{
            throw new Error("同名模块已存在，不能重复添加！");
        }
    },

    /**
     * 得到模块
     * @param name
     * @returns {V}
     */
    get:function (name) {
        return modules.get(name)
    },

    /**
     * 获取所有模块
     */
    getAll:function () {
        return modules;
    },

    /**
     * 模块是否存在
     * @param name
     * @returns {boolean}
     */
    isExist: function (name) {
        return modules.has(name);
    }

};