# 前端控件 #
**前端控件**将前端常用的功能进行抽象为控件，用标签的形式进行使用。


## 功能说明 ##
- 组件基类--编写组件都需要继承该基础类
- 下拉框控件--生成下拉框html代码
- 单选框控件--生成单选框html代码
- 复选框控件--生成复选框html代码
- 日期控件--生成日期选择框html代码
- 范围日期控件--生成范围日期选择框html代码
- 弹出列表选择控件--生成弹出的列表框的html代码
- 弹出树形选择控件--生成弹出的树型选择框的html代码
- 弹出树形列表选择控件--生成弹出的左边树型右边列表的html代码

## 使用说明 ##
### 组件基类
 * html中e-标签的公用属性（继承该基类的控件都有公共属性）：
 * e-url ===> 类中的url属性，用于数据读取的地址  
 * e-unique ==> 用于缓存的唯一标识key，如果使用该属性则启用缓存（可选）  
 * e-type ===> 类中的type属性，用于ajax的类型，默认post，如果是get类型的http请求需要设置e-type=get  
 * e-urlparam===>类中的urlparam属性，ajax在读取url前如果发现有该属性则会到参数中查找该属性对应的值，如果不存在则不读取url，常用于级联的使用中  
 * e-url-ajax-data====>类中urlAjaxData属性，通常用于给post方式的url传递参数，也可以用于get请求，格式为name:val,xx:fafa,ww:fw的形式
 * e-domopt ======>类中的domopt属性，用于对目标定位元素加入html的方式，默认为replace操作，替换目标元素，其他方式请参照domOptType方法（可选，基本用不到）
 * e-url-ajax-data====>类中urlAjaxData属性，通常用于给post方式的url传递参数，也可以用于get请求，格式为name:val,xx:fafa,ww:fw的形式
 * e-container-* =====>标签中设置该开头的属性会在容器div中生成自定义属性，方便第三方操作容器div。例如要在容器div中添加class和fsw属性：e-container-class="ww a b orc" e-container-fsw="abc"
####注意
   其他组件类继承该基类时，args.id不要再进行设置，基类已经进行了处理，会去dom元素的id，dom没有id则会使用name，如果都没有则会设置对象本身生成的id。

### 下拉框控件
 * 标签名称e-select
 * 标签中的属性：
 * e-option-value ===> 类optionValue属性，下拉框选项的value
 * e-option-text ===> 类optionText属性，下拉框选项的文字
 * e-value ===> 类中的value属性，默认值
 * e-target ===> 类中的target属性，用于级联的情况，target为要影像的下拉框的id，在级联情况会添加onchange事件把本下拉框的value传给target对象
 * e-multiple===> 下拉框多选 写法：e-multiple="multiple"
 * 其他：都为html原生属性或者其他第三方组件使用属性
 * html中使用举例如下：
```<e-select class="form-control"  name="gwType" e-unique="gwType" e-option-value="code" 
                                   e-option-text="value" e-url="/test/dictionary/getChildrenByCode?code=gwType" e-value='sc'
                                   e-type="get" e-event="event:change,href:/showcase/comtest/test" 
                                   datatype="*"  >
                                  </e-select>```
### 单选框控件
 * 标签名称e-radio  
 * 标签中的属性：
 * e-option-value ===> 类optionValue属性，生成的单选按钮的value
 * e-option-text ===> 类optionText属性，生成的单选按钮的文字
 * e-value ===> 类中的value属性，默认符合该value的单选按钮被选中
 * 其他：都为html原生属性或者其他第三方组件使用属性
 * html中使用举例如下：
   <e-radio class="form-control"   name="gwTypecc2" e-option-value="code" e-type='get'
      e-option-text="value" e-url="/test/dictionary/getChildrenByCode?code=gwType" e-value='sc'
      e-domopt='replace'   datatype="*"  > </e-radio>
### 复选框控件
 * 标签名称e-checkbox
 * 标签中的属性：
 * e-option-value ===> 类optionValue属性，生成的复选框的value
 * e-option-text ===> 类optionText属性，生成的复选框的文字
 * e-value ===> 类中的value属性，默认符合该value的复选框被选中，多个默认值请用“,”分隔，如：e=value="a,b,c"
 * e-multiselect ===> multiselect属性，默认true，如果为false则只能选择一个
 * 其他：都为html原生属性或者其他第三方组件使用属性
 * html中使用举例如下：
   <e-checkbox class="form-control"   name="gwTypecc2" e-option-value="code" e-type='get'
      e-option-text="value" e-url="/test/dictionary/getChildrenByCode?code=gwType" e-value='sc,gl'
      e-domopt='replace'   datatype="*"  > </e-checkbox>
### 日期控件
 * 标签名称e-datetimepicker
 * 标签中的属性：
 * e-value ===>时间框的默认显示值
 * e-format ===>时间框的日期时间显示格式，yyyy-MM-dd hh:mm:ss
 * 其他：都为html原生属性或者其他第三方组件使用属性
 * 注意：id属性为必填
 * html中使用举例如下：
   <e-datetimepicker id="search_createDate2" name="search_createDate2" class="form-control" 
   e-value="2016-06-12" e-format="yyyy-MM-dd"></e-datetimepicker>
### 范围日期控件
 * 标签名称e-daterangepicker
 * 标签中的属性：
 * e-value ===>时间框的默认显示值
 * e-format ===>时间框的日期时间显示格式，yyyy-MM-dd hh:mm:ss
 * 其他：都为html原生属性或者其他第三方组件使用属性
 * 使用实例如下：
   <e-daterangepicker name="search_createDate2" class="form-control" style="min-width:120px;" 
   readonly e-value="2015-06-12到2017-11-23" e-format="yyyy-MM-dd"> </e-daterangepicker>
### 弹出列表选择控件
 * 标签名称e-popu
 * 标签中的属性：
 * e-option-value-title 选中数据显示的列的名称的标题
 * e-option-value       选中数据显示的列编码字段code，默认“code”
 * e-option-text-title  选中数据对应的汉字的字段名称，默认“名称”
 * e-option-text        选中数据的编码对应的汉字的字段code ，默认“value”
 * e-title              弹出窗口标题，默认“信息”
 * e-query-static-param 查询地址如果是post提交所需要的表单固定参数（如果没有参数可不填）
 * e-query-param        查询条件（如果没有参数可不填）
 * e-query-param-name   查询条件名称（如果没有参数可不填）
 * e-display-columns    列表中显示的列的code
 * e-display-columnnames列表中显示的列的名称，顺序与e-display-columns中对应的元素相同
 * e-value              控件默认显示值，多个值用“,”隔开
 * e-value-name         控件默认显示值对应的名称，多个值与e-value的元素对应
 * e-multiple="multiple"标识列表为多选
 * e-width              弹出窗口宽度，默认800px
 * e-height             弹出窗口高度，默认600px
 * e-z-index            弹出窗口高度zIndex设置  e-z-index="100"
 * e-shade              弹出窗口遮罩设置，语法与layer同，例如e-shade="[0.8, '#393D49']
  * 必填的html原生属性
 * id,name
 *  回调函数：
 * onCheck            多选情况下，选中复选框时触发，可以从注册的函数参数中获取到选中行的data，
 *                     testCheck(args) args.data极为该行数据
 * onUncheck          多选情况下，复选框取消选中时触发，其他用法同上
 * onSelected         单选情况下，选中行事件  
 * 使用实例如下：
 * <e-popu id="popu1" name="popu1" e-url="/test/dictionary/getChildrenByCode/pages"
 e-unique="gwType" e-option-value-title="编码2" e-option-value="code"
 e-option-text-title="名称3" e-option-text="value" e-title="弹出页面1"
 e-query-static-param="code:gwType"
 e-query-param = "search_code,search_value"
 e-query-param-name = "编码1,名称"
 e-width="800px" e-height="500px"
 e-display-columns="value,code"
 e-display-columnnames="单位名称,单位编码"
 e-value="gl"
 e-value-name="管理"
 e-on-check="/comtest/comtest/testCheck?name=t3&age=13"
 e-on-uncheck="/comtest/comtest/testUnCheck?name=t3&age=13"
 e-on-selected="/comtest/comtest/testOnSelected?name=t31&age=45"
 >
 </e-popu>
### 弹出树形选择控件
 * 标签名称e-poptree
 * 标签中的属性：
 * e-chkbox-type       选择方式：
   1：多选，叶子节点被返回（默认类型）
   2：多选，父节点或者叶子节点都返回
   3：单选，只能选中一个节点
   4：单选2，同一级目录只能选择一个
 * e-expand-level       展开级别，默认0
 * e-option-value-title 数据中编码的字段名称，默认“编码”
 * e-option-value       数据中的编码字段code，默认“code”
 * e-option-text-title  数据中的编码对应的汉字的字段名称，默认“名称”
 * e-option-text        数据中的编码对应的汉字的字段code ，默认“value”
 * e-data-id            数据中的唯一标识字段，默认“id”
 * e-data-parent-id     数据中上级的唯一标识字段，默认“pId”
 * e-title              弹出窗口标题，默认“信息”
 * e-query-param        查询地址如果是post提交所需要的表单参数（如果没有参数可不填）
 * e-width              弹出窗口宽度，默认800px
 * e-height             弹出窗口高度，默认600px
 * 必填的html原生属性
 * id,name
 * 使用实例如下：
 * <e-poptree id="poputree2" name="poputree2" e-url="/test/core/organization/list"  
                                e-unique="orgType"  e-option-value="orgCode" e-option-text="name"
                                e-option-text-title="名称3" e-option-text="value" e-title="弹出页面tree1"
                                e-data-id="id" e-data-parent-id="pId"
                                e-display-columns="name,orgCode,pId"
                                e-display-columnnames="单位名称,单位编码,父id"
                                e-width="400px" e-height="500px">
                                </e-poptree>
### 弹出树形列表选择控件
 * 标签名称e-poptreelist
 * 标签中的属性：
 * e-expand-level       展开级别，默认0
 * e-option-value-title 数据中编码的字段名称，默认“编码”
 * e-option-value       数据中的编码字段code，默认“code”
 * e-option-text-title  数据中的编码对应的汉字的字段名称，默认“名称”
 * e-option-text        数据中的编码对应的汉字的字段code ，默认“value”
 * e-data-id            数据中的唯一标识字段，默认“id”
 * e-data-parent-id     数据中上级的唯一标识字段，默认“pId”
 * e-title              弹出窗口标题，默认“信息”
 * e-query-param        查询地址如果是post提交所需要的表单参数（如果没有参数可不填）
 * e-width              弹出窗口宽度，默认800px
 * e-height             弹出窗口高度，默认600px
 * 必填的html原生属性
 * id,name
 * 回调函数：
 * onCheck            多选情况下，选中复选框时触发，可以从注册的函数参数中获取到选中行的data，
 *                     testCheck(args) args.data极为该行数据
 * onUncheck          多选情况下，复选框取消选中时触发，其他用法同上
 * onSelected         单选情况下，选中行事件       
 * 使用实例如下：
 * <e-poptreelist id="poputreelist1" name="poputreelist1"
 e-tree-url="/test/core/organization/list"
 e-list-url="/test/core/user/list"
 e-option-value="account" e-option-text="name"
 e-option-text-title="名称3"  e-title="弹出页面tree1"
 e-data-id="id" e-data-parent-id="pId"
 e-display-columns="account,name,orgName"
 e-display-columnnames="登录账户,用户名称,所属机构"
 e-chkbox-type="1"
 e-expand-level="0"
 e-width="1000px" e-height="300px" e-com-height="500px"
 e-value="test" e-value-name="测试用户"
 e-multiple="multiple"
 e-query-param = "search_LIKE_name,search_LIKE_account"
 e-query-param-name = "用户名,账户"
 e-query-tree-list-param = "id:search_LIKE_organization.orgPath"
 e-on-check="/comtest/comtest/testCheck?name=t3&age=13"
 e-on-uncheck="/comtest/comtest/testUnCheck?name=t3&age=13"
 e-on-selected="/comtest/comtest/testOnSelected?name=t31&age=45"
 >
 </e-poptreelist>
### 业务Js中用法举例
1、业务代码中获取标签的组件对象重新渲染html
let esel = ComponentManager.getComObjectByDomId('czlx1');//dom的id为czlx1，必须有id才能获取  
esel.updateArgs({//重新设置变化的参数  
     url:'/system/core/dictionary/getSonDicsByCode?code=resctype'  
            });  
esel.refresh();//重新渲染html  
也可以直接写为：  
esel.refresh({url:'/system/core/dictionary/getSonDicsByCode?code=resctype' });