/**
 * Created by zhaofs on 2016/7/19.
 * --------------------
 * - 处理器 -
 * --------------------
 * 界面中的操作实现，比如，增删改查等等操作，并把增删改查进一步抽象为查询(search)和提交(showDialog、submit);
 */

import BaseHandler from "./BaseHandler";

let objectAppend=function(original){
    let i = 1, l = arguments.length;
    for (; i < l; i++){
        let extended = arguments[i] || {};
        for (let key in extended) original[key] = extended[key];
    }
    return original;
};

let objectFilter=function(object, fn, bind){
    let results = {};
    let keys = Object.keys(object);
    for (let i = 0; i < keys.length; i++){
        let key = keys[i], value = object[key];
        if (fn.call(bind, value, key, object)) results[key] = value;
    }
    return results;
};

export default class extends BaseHandler{

    constructor(options) {
        super(options);
        this.ajaxBasePath=options.ajaxBasePath||this.ajaxBasePath;
        this.modulePath=options.modulePath||this.modulePath;

        //添加继承属性
        if(options.extends){
            Object.assign(this,options.extends);
        }

        //绑定新追加的方法
        objectAppend(this, objectFilter(options || {}, function (value, key) {
            return !(/^on[A-Z]/).test(key) && typeof(value) === 'function';
        }));


        //add lhw 20160812 调用各自Handler的初始化函数
        if (this.initHandler) {
            this.initHandler();
        }
        //add end

    }
};