/**
 * Created by zhaofs on 2016/7/19.
 * --------------------
 * - 调度器 -
 * --------------------
 * 根据锚点定位Handler并执行指定方法
 */
import handlerUtils from "./HandlerUtils";
import Processor from "../base/Processor";
import aspectManager from "../aspect/AspectManager";

export default class extends Processor {
    /**
     * 初始化调度器
     */
    initDispatcher() {
        window.addEventListener('hashchange', this.dispatch.bind(this), false);
    }


    /**
     * Handler调度
     * @param isActivateMenu 是否激活菜单
     */
    dispatch(isActivateMenu = true) {
        let href = location.hash.slice(1);
        if (href) {
            //激活菜单
            if (isActivateMenu && window.ezdev.config.sidebarMenu) {
                window.ezdev.config.sidebarMenu.activateMenu();
            }

            //Handler方法调用
            let handlerMapping = handlerUtils.resolveHandler(href);
            aspectManager.doRouteBefore(handlerMapping, () => {
                handlerUtils.invokeHandler(handlerMapping.path, handlerMapping.method, handlerMapping.args);
            });
            aspectManager.doRouteAfter(handlerMapping, href);
        }

    }
};