/**
 * Created by zhaofs on 2016/9/12.
 * --------------------
 * - 导航栏容器 -
 * --------------------
 * 用户维护管理右上角中的菜单
 */
import Event from "../../base/Events";
import renderer from "../../render/Renderer";
import handlerManager from "../../handler/HandlerManager";

const navs = new Map();

export default class extends Event {
    constructor(id) {
        super();
        this._id = id;
    }

    add(nav) {
        navs.set(nav.name, nav);
        handlerManager.staticImportByName(nav.name, nav)
    }

    initNavbar() {

        //顶端菜单栏排序
        let navMenus = Array.from(navs.values()).sort(function (a, b) {
            if (a.order > b.order) {
                return 1;
            }
            if (a.order < b.order) {
                return -1;
            }
            return 0;
        });

        //对生成的顶端菜单栏进行渲染
        navMenus.forEach((nav) => {
            $(`#${this.id}`).prepend(nav.generateHtml());
            nav.disposeHtml(this.id);

            console.log(`nav[${nav.name}] render process finished.`);
        });

        renderer.analyzeHtml(this.id);
    }

    has(name) {
        return navs.has(name)
    }

    get(key){
        return navs.get(key)
    }

    get id() {
        return this._id;
    }

    set id(value) {
        this._id = value;
    }


};