/**
 * Created by zhaofs on 2016/7/21.
 * --------------------
 * - 分析器基本类 -
 * --------------------
 * 实现各种自定义属性分析，主要时对页面片段加载完成后对html元素的预处理
 */
import Processor from "../../base/Processor";

export default class extends Processor {
    /**
     * 基本分析器，实现用
     * @param name 分析器名称
     * @param order 排序
     */
    constructor(name, order) {
        super(name);
        if (name) {
            this._name = name;
        } else {
            throw new Error("参数无效，请在子类中指定分析器的名称");
        }
        this._order = order || 1024;
    }

    /**
     * 对元素分析器进行初始化
     */
    initAnalyzer() {
        return this;
    }

    /**
     * 对元素进行分析
     * @param content
     */
    analyze(content) {
    }

    get name() {
        return this._name;
    }

    set name(value) {
        this._name = value;
    }

    get order() {
        return this._order;
    }

    set order(value) {
        this._order = value;
    }
};