/**
 * Created by wangchen on 2017/7/26.
 * --------------------
 * - 组件分析器类 -
 * --------------------
 * 实现各种自定义属性分析，主要时对页面片段加载完成后对html元素的预处理
 */
import BaseAnalyzer from "./BaseAnalyzer";

import runtime from "art-template/lib/runtime";
import cacheUtils from "../../cache/CacheUtils";

import componentManager from "../../components/ComponentManager";

export default class extends BaseAnalyzer {

    constructor() {
        super("ComponentAnalyzer",0);
    }

    initAnalyzer() {
        this.addTplHelper();
        return this;
    }

    analyze(content) {
        let tags = componentManager.getAllComNames();
        $(content).find(tags.join(',')).each(function (index, items) {
            componentManager.renderHtml(items);
        });
    }

    /**
     * 添加template辅助方法，支持根据code获取显示名称,如：
     * {{key | display:'unique'}} 显示方法返回值
     */
    addTplHelper() {
        runtime.display = function (key, prefix) {
            return cacheUtils.get(prefix + key);
        };
    }

};