/**
 * Created by zhaofs on 2017/10/26.
 * --------------------
 * - 权限分析器 -
 * --------------------
 * 权限分析处理，对有属性e-permission的元素进行分析，有权限就显示无权限不显示
 */
import config from "../../Config";
import BaseAnalyzer from "./BaseAnalyzer";

export default class extends BaseAnalyzer {
    constructor() {
        super("PermissionAnalyzer", 1);
    }

    analyze(content) {
        if (config.user.account !== 'admin' && config.permissionsEnable) {
            let permissions = $(content).find('[' + config.permissionTag + ']');
            permissions.each(function (index, item) {
                let permissionItem = $(item), permission = permissionItem.attr(config.permissionTag);
                if (permission && config.permissions.indexOf(permission) < 0) {
                    permissionItem.hide();
                }
            }.bind(this));
        }
    }
};