/**
 * Created by zhaofs on 2016/7/21.
 * --------------------
 * - 表单验证事件分析器 -
 * --------------------
 * 事件分析处理，对有属性dataType的元素进行分析，并进行相应的事件处理
 */

import config from "../../Config";
import BaseAnalyzer from "./BaseAnalyzer";

export default class extends BaseAnalyzer {
    constructor() {
        super("ValidFormAnalyzer",20);
    }

    analyze(content) {
        let handles = $(content).find('[' + config.validformTag + ']');
        if (handles.length > 0) {
            let $form = $(handles[0]).closest("form");
            $form.Validform({
                tiptype: function (msg, o, cssctl) {
                    //msg：提示信息;
                    //o:{obj:*,type:*,curform:*}, obj指向的是当前验证的表单元素（或表单对象），type指示提示的状态，值为1、2、3、4， 1：正在检测/提交数据，2：通过验证，3：验证失败，4：提示ignore状态, curform为当前form对象;
                    //cssctl:内置的提示信息样式控制函数，该函数需传入两个参数：显示提示信息的对象 和 当前提示的状态（既形参o中的type）;
                    let objtip = o.obj.siblings(".help-block");
                    // let objtip = o.obj.parents('div[elbs]').siblings(".help-block");
                    if(objtip.length==0){
                        // objtip = o.obj.parent().siblings(".help-block");
                        objtip = o.obj.parents('div[elbs]').siblings(".help-block");
                    }

                    let objgroup = objtip.closest(".form-group");

                    switch (o.type) {
                        case 1:
                            objgroup.removeClass("has-success has-error").addClass("has-warning");
                            objgroup.find('label .fa').removeClass("fa-check fa-times-circle-o").addClass("fa-bell-o");
                            break;
                        case 2:
                            objgroup.removeClass("has-error has-warning").addClass("has-success");
                            objgroup.find('label .fa').removeClass("fa-times-circle-o fa-bell-o").addClass("fa-check");
                            break;
                        case 4:
                            objgroup.removeClass("has-error has-success").addClass("has-warning");
                            objgroup.find('label .fa').removeClass("fa-check fa-times-circle-o").addClass("fa-bell-o");
                            break;
                        default:
                            objgroup.removeClass("has-success has-warning").addClass("has-error");
                            objgroup.find('label .fa').removeClass("fa-check fa-bell-o").addClass("fa-times-circle-o");
                    }

                    cssctl(objtip, o.type);
                    objtip.text(msg);
                },
                ajaxPost: false
            });
        }
    }
};