/**
 * Created by zhaofs on 2018/1/24.
 * --------------------
 * - 用户信息相关 -
 * --------------------
 */
import config from "../Config";
import ajaxRequest from "../ajax/AjaxRequest";

export default {

    /**
     * ajax获取用户信息
     * @returns {Promise}
     */
    getUserByAjax: function () {
        return new Promise((resolve) => {
            if (config.userInfoUrl) {
                ajaxRequest.ajax({
                    url: config.userInfoUrl,
                    type: "get"
                }).then((data) => {
                    config.user = data.data.user;
                    resolve(data);
                })
            } else {
                resolve(null);
            }

        });
    }
};